/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the PostMeEntrypoints200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &PostMeEntrypoints200Response{}

// PostMeEntrypoints200Response struct for PostMeEntrypoints200Response
type PostMeEntrypoints200Response struct {
	ChannelId *string `json:"channel_id,omitempty"`
	CreatedAt *time.Time `json:"created_at,omitempty"`
	CustomerExperienceId *string `json:"customer_experience_id,omitempty"`
	Id *string `json:"id,omitempty"`
	OrganizationId *string `json:"organization_id,omitempty"`
	Ttl *int32 `json:"ttl,omitempty"`
	Type *string `json:"type,omitempty"`
}

// NewPostMeEntrypoints200Response instantiates a new PostMeEntrypoints200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewPostMeEntrypoints200Response() *PostMeEntrypoints200Response {
	this := PostMeEntrypoints200Response{}
	return &this
}

// NewPostMeEntrypoints200ResponseWithDefaults instantiates a new PostMeEntrypoints200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewPostMeEntrypoints200ResponseWithDefaults() *PostMeEntrypoints200Response {
	this := PostMeEntrypoints200Response{}
	return &this
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *PostMeEntrypoints200Response) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetCreatedAt() time.Time {
	if o == nil || IsNil(o.CreatedAt) {
		var ret time.Time
		return ret
	}
	return *o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreatedAt) {
		return nil, false
	}
	return o.CreatedAt, true
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasCreatedAt() bool {
	if o != nil && !IsNil(o.CreatedAt) {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given time.Time and assigns it to the CreatedAt field.
func (o *PostMeEntrypoints200Response) SetCreatedAt(v time.Time) {
	o.CreatedAt = &v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetCustomerExperienceId() string {
	if o == nil || IsNil(o.CustomerExperienceId) {
		var ret string
		return ret
	}
	return *o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetCustomerExperienceIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasCustomerExperienceId() bool {
	if o != nil && !IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given string and assigns it to the CustomerExperienceId field.
func (o *PostMeEntrypoints200Response) SetCustomerExperienceId(v string) {
	o.CustomerExperienceId = &v
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *PostMeEntrypoints200Response) SetId(v string) {
	o.Id = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *PostMeEntrypoints200Response) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetTtl returns the Ttl field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetTtl() int32 {
	if o == nil || IsNil(o.Ttl) {
		var ret int32
		return ret
	}
	return *o.Ttl
}

// GetTtlOk returns a tuple with the Ttl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetTtlOk() (*int32, bool) {
	if o == nil || IsNil(o.Ttl) {
		return nil, false
	}
	return o.Ttl, true
}

// HasTtl returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasTtl() bool {
	if o != nil && !IsNil(o.Ttl) {
		return true
	}

	return false
}

// SetTtl gets a reference to the given int32 and assigns it to the Ttl field.
func (o *PostMeEntrypoints200Response) SetTtl(v int32) {
	o.Ttl = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *PostMeEntrypoints200Response) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *PostMeEntrypoints200Response) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *PostMeEntrypoints200Response) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *PostMeEntrypoints200Response) SetType(v string) {
	o.Type = &v
}

func (o PostMeEntrypoints200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o PostMeEntrypoints200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.CreatedAt) {
		toSerialize["created_at"] = o.CreatedAt
	}
	if !IsNil(o.CustomerExperienceId) {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.Ttl) {
		toSerialize["ttl"] = o.Ttl
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullablePostMeEntrypoints200Response struct {
	value *PostMeEntrypoints200Response
	isSet bool
}

func (v NullablePostMeEntrypoints200Response) Get() *PostMeEntrypoints200Response {
	return v.value
}

func (v *NullablePostMeEntrypoints200Response) Set(val *PostMeEntrypoints200Response) {
	v.value = val
	v.isSet = true
}

func (v NullablePostMeEntrypoints200Response) IsSet() bool {
	return v.isSet
}

func (v *NullablePostMeEntrypoints200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullablePostMeEntrypoints200Response(val *PostMeEntrypoints200Response) *NullablePostMeEntrypoints200Response {
	return &NullablePostMeEntrypoints200Response{value: val, isSet: true}
}

func (v NullablePostMeEntrypoints200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullablePostMeEntrypoints200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


